@using Jones.AspNetCore.Utils
@using Microsoft.Extensions.Options
@using Jones.AspNetCore.TailwindCSS.FlowBite.Types
@inherits ButtonBase

<button @attributes="@AdditionalAttributes" class="@Class" role="button" disabled="@Disabled" aria-disabled="@Disabled" @onclick="@OnClick"
        @onclick:preventDefault="@PreventDefault" @onclick:stopPropagation="@StopPropagation">
    @if (IsLoading == true)
    {
        if (!string.IsNullOrEmpty(ActualLoadingIcon))
        {
            <span class="mr-1.5">
                <i class="@ActualLoadingIcon"></i>
            </span>
        }
        else
        {
            <svg aria-hidden="true" role="status" class="inline w-4 h-4 mr-2 text-white animate-spin" viewBox="0 0 100 101" fill="none" xmlns="http://www.w3.org/2000/svg">
                <path d="M100 50.5908C100 78.2051 77.6142 100.591 50 100.591C22.3858 100.591 0 78.2051 0 50.5908C0 22.9766 22.3858 0.59082 50 0.59082C77.6142 0.59082 100 22.9766 100 50.5908ZM9.08144 50.5908C9.08144 73.1895 27.4013 91.5094 50 91.5094C72.5987 91.5094 90.9186 73.1895 90.9186 50.5908C90.9186 27.9921 72.5987 9.67226 50 9.67226C27.4013 9.67226 9.08144 27.9921 9.08144 50.5908Z" fill="#E5E7EB"/>
                <path d="M93.9676 39.0409C96.393 38.4038 97.8624 35.9116 97.0079 33.5539C95.2932 28.8227 92.871 24.3692 89.8167 20.348C85.8452 15.1192 80.8826 10.7238 75.2124 7.41289C69.5422 4.10194 63.2754 1.94025 56.7698 1.05124C51.7666 0.367541 46.6976 0.446843 41.7345 1.27873C39.2613 1.69328 37.813 4.19778 38.4501 6.62326C39.0873 9.04874 41.5694 10.4717 44.0505 10.1071C47.8511 9.54855 51.7191 9.52689 55.5402 10.0491C60.8642 10.7766 65.9928 12.5457 70.6331 15.2552C75.2735 17.9648 79.3347 21.5619 82.5849 25.841C84.9175 28.9121 86.7997 32.2913 88.1811 35.8758C89.083 38.2158 91.5421 39.6781 93.9676 39.0409Z" fill="currentColor"/>
            </svg>
        }
    }
    else
    {
        if (!string.IsNullOrEmpty(Icon))
        {
            <span class="mr-1.5">
                <i class="@Icon"></i>
            </span>
        }
    }

    <CascadingValue Value="this" IsFixed="true">
        @ChildContent
    </CascadingValue>
</button>

@inject IOptions<ButtonConfig> Config;
@code{
    // [Parameter]
    // public bool IsOutline { get; set; }
    
    [Parameter]
    public bool PreventDefault { get; set; } = false;
    
    [Parameter]
    public bool StopPropagation { get; set; } = false;
    
    [Parameter]
    public ThemeColor ThemeColor { get; set; } = ThemeColor.Primary;
    
    [Parameter]
    public Size Size { get; set; } = Size.Medium;

    private string? Class => CssBuilder.Default("focus:ring-4 rounded-lg focus:outline-none inline-flex items-center justify-center")
        .AddClass(GetThemeColorClass())
        .AddClass(GetSizeClass())
        .AddClass("cursor-wait", IsLoading == true)
        .AddClass("cursor-not-allowed", IsDisabled && IsLoading != true)
        .AddClassFromAttributes(AdditionalAttributes)
        .Build();

@*     <button type="button" class="text-gray-900 bg-white border border-gray-300 focus:outline-none hover:bg-gray-100  *@
@*         focus:ring-4 focus:ring-gray-100 font-medium rounded-lg text-sm px-5 py-2.5 me-2 mb-2 dark:bg-gray-800 dark:text-white  *@
@*         dark:border-gray-600 dark:hover:bg-gray-700 dark:hover:border-gray-600 dark:focus:ring-gray-700"> *@
@*         Light *@
@*     </button> *@
    
    private string GetThemeColorClass()
    {
        return ThemeColor switch
        {
            ThemeColor.Primary => IsDisabled 
                ? "text-white bg-blue-400 dark:bg-blue-500 cursor-not-allowed" 
                : "text-white bg-blue-700 hover:bg-blue-800 focus:ring-blue-300 dark:bg-blue-600 dark:hover:bg-blue-700 dark:focus:ring-blue-800",
            ThemeColor.Secondary => IsDisabled 
                ? "text-white bg-gray-400 dark:bg-gray-500 cursor-not-allowed" 
                : "text-white bg-gray-700 hover:bg-gray-800 focus:ring-gray-300 dark:bg-gray-600 dark:hover:bg-gray-700 dark:focus:ring-gray-800",
            ThemeColor.Success => IsDisabled 
                ? "text-white bg-green-400 dark:bg-green-500 cursor-not-allowed" 
                : "text-white bg-green-700 hover:bg-green-800 focus:ring-green-300 dark:bg-green-600 dark:hover:bg-green-700 dark:focus:ring-green-800",
            ThemeColor.Danger => IsDisabled 
                ? "text-white bg-red-400 dark:bg-red-500 cursor-not-allowed" 
                : "text-white bg-red-700 hover:bg-red-800 focus:ring-red-300 dark:bg-red-600 dark:hover:bg-red-700 dark:focus:ring-red-900",
            ThemeColor.Warning => IsDisabled 
                ? "text-white bg-yellow-100 dark:bg-yellow-200 cursor-not-allowed" 
                : "text-white bg-yellow-400 hover:bg-yellow-500 focus:ring-yellow-300 dark:focus:ring-yellow-900",
            ThemeColor.Info => IsDisabled 
                ? "text-white bg-indigo-400 dark:bg-indigo-500 cursor-not-allowed" 
                : "text-white bg-indigo-700 hover:bg-indigo-800 focus:ring-indigo-300 dark:bg-indigo-600 dark:hover:bg-indigo-700 dark:focus:ring-indigo-800",
            ThemeColor.Light => IsDisabled 
                ? "text-gray-900 bg-gray-100 dark:bg-gray-100 cursor-not-allowed" 
                : "text-gray-900 bg-white border border-gray-300 hover:bg-gray-100 focus:ring-4 focus:ring-gray-100 dark:text-white dark:bg-gray-800 dark:border-gray-600 dark:hover:bg-gray-700 dark:hover:border-gray-600 dark:focus:ring-gray-700",
            _ => throw new ArgumentOutOfRangeException()};
    }

    private string GetSizeClass()
    {
        return Size switch {
            Size.ExtraSmall => "px-3 py-2 text-xs",
            Size.Small => "px-3 py-2 text-sm",
            Size.Medium => "px-5 py-2",
            Size.Large => "px-5 py-3 text-base",
            Size.ExtraLarge => "px-6 py-3.5 text-base",
            _ => throw new ArgumentOutOfRangeException()};
    }

    private string? ActualLoadingIcon => !string.IsNullOrEmpty(LoadingIcon)
        ? LoadingIcon
        : Config.Value.LoadingIcon;
}